import type { NextApiRequest, NextApiResponse } from "next";
import type { Schema } from "../types/schema";
declare type ValueOf<T> = T[keyof T];
declare type OrPromise<T> = T | Promise<T>;
export declare function route<S extends Schema<any, any, any>>(schemaName: string, handler: (req: Omit<NextApiRequest, "body"> & {
    query: S["query"];
    body: S["body"];
}, res: NextApiResponse<ValueOf<S["responses"]>>) => OrPromise<Partial<S["responses"]> | void>): typeof handler;
export {};
